
ParticleDefinitions[GaugeES] = {
      {SdL,  {  Description -> "Left Down-Squarks"}},
      {SdR,  { Description -> "Right Down-Squarks"}},
      {SuL,  { Description -> "Left Up-Squarks"}}, 
      {SuR,  { Description -> "Right Up-Squarks" }},                
      {SeL,  { Description -> "Left Selectron"}}, 
      {SeR,  { Description -> "Right Selectron"}},                         
      {SvL,  { Description -> "Left Sneutrino"}},                         
      {SHd0, { Description -> "Neutral Down-Higgs"}},                         
      {SHdm, { Description -> "Charged Down-Higgs"}}, 
      {SHu0, { Description -> "Neutral Up-Higgs"}},                         
      {SHup, { Description -> "Charged Up-Higgs"}},                                                   
      {VB,   { Description -> "B-Boson"}},                                                   
      {VG,   { Description -> "Gluon"}},          
      {VWB,  { Description -> "W-Bosons"}},          
      {gB,   { Description -> "B-Boson Ghost"}},                                                   
      {gG,   { Description -> "Gluon Ghost" }},          
      {gWB,  { Description -> "W-Boson Ghost"}},    
      {Glu,  { Description -> "Gluino"}},
      {Wino, { Description -> "Wino"}},
      {Bino, { Description -> "Bino"}},                                                                                           
      {H0,   { Description -> "Neutral Higgsinos"}},
      {HC,   { Description -> "Charged Higgsinos"}},
      {Fd1,  { Description -> "Dirac Left Down-Quark"}},
      {Fd2,  { Description -> "Dirac Right Down-Quark"}},
      {Fu1,  { Description -> "Dirac Left Up-Quark"}},
      {Fu2,  { Description -> "Dirac Right Up-Quark"}},
      {Fe1,  { Description -> "Dirac Left Electron"}},
      {Fe2,  { Description -> "Dirac Right Electron"}},
      {Fv,   { Description -> "Neutrinos" }},
      {St1,  {LaTeX -> "\\tilde{t'}"}},
      {St2,  {LaTeX -> "\\tilde{\\bar{t}}'"}}
      };
      
      
      
      
  ParticleDefinitions[EWSB] = {
      {Sd ,  { Description -> "Down-Squarks",
        PDG ->  {1000001,1000003,1000005,2000001,2000003,2000005},
                PDG.IX -> {-200890201,-200890202,-200890203,-200890204,-200890205,-200890206}}},
      {Su ,  { Description -> "Up-Squarks",
  PDG ->  {1000002,1000004,1000006,2000002,2000004,2000006,3000002,3000004},
                PDG.IX -> {200100401,200100402,200100403,200100404,200100405,200100406,200100407,200100408}

}},   

{FVeR, {PDG->{502},
           OutputName -> "Fep",
           FeynArtsNr -> 50,
           LaTeX->"{\\Psi^{e_R}}",
           ElectricCharge->-1}},
{FVdL, {PDG->{503},
           OutputName -> "Fdp",
           FeynArtsNr -> 51,
           LaTeX->"{\\Psi^{d_L}}",           
           ElectricCharge->-1/3}},
{FVuL, {PDG->{505},
           OutputName -> "Ftp",
           FeynArtsNr -> 52,           
           LaTeX->"{\\Psi^{u_L}}",           
           ElectricCharge -> 2/3}},
           
{StpL, {PDG->{4000002, 4000004},
           OutputName -> "Stp",
            LaTeX->"{\\Phi^{t_L}}",                
           FeynArtsNr -> 52,           
           ElectricCharge -> 2/3}},           
           
{SbpL, {PDG->{3000001,3000003},
           OutputName -> "Sbp",
           FeynArtsNr -> 51,           
            LaTeX->"{\\Phi^{b_L}}",                           
           ElectricCharge->-1/3}},   
           
{SepL, {PDG->{3000011,3000013},
           OutputName -> "Sep",
           FeynArtsNr -> 50,  
            LaTeX->"{\\Phi^{e_L}}",                           
           ElectricCharge->-1}},   
           


      {Se ,  { Description -> "Sleptons",
      PDG ->  {1000011,1000013,1000015,2000011,2000013,2000015},
                PDG.IX -> {-200000601,-200000602,-200000603,-200000604,-200000605,-200000606}}}, 
      {Sv ,  { Description -> "Sneutrinos"}},                                
      {hh ,  { Description -> "Higgs"}}, 
      {Ah ,  { Description -> "Pseudo-Scalar Higgs"}},                       
      {Hpm,  { Description -> "Charged Higgs"}},                                                   
      {VP,   { Description -> "Photon"}}, 
      {VZ,   { Description -> "Z-Boson"}}, 
      {VG,   { Description -> "Gluon" }},          
      {VWm,  { Description -> "W-Boson" }},         
      {gP,   { Description -> "Photon Ghost"}},                                                   
      {gWm,  { Description -> "Negative W-Boson Ghost"}}, 
      {gWmC, { Description -> "Positive W-Boson Ghost" }}, 
      {gZ,   { Description -> "Z-Boson Ghost" }},
      {gG,   { Description -> "Gluon Ghost" }},             
      {Fd,   { Description -> "Down-Quarks"}},   
      {Fu,   { Description -> "Up-Quarks",
  PDG -> {2,4,6,8},
                 PDG.IX->{110100401,110100402,110100403,110100404}}},   
      {Fe,   { Description -> "Leptons" }},
      {Fv,   { Description -> "Neutrinos" }},                                                                     
      {Glu,  { Description -> "Gluino" }},
      {Chi,  { Description -> "Neutralinos"}},
      {Cha,  { Description -> "Charginos"}},
      {GOL,  { Description -> "Goldstino"}},                                                                                               
      {GMU,  { Description -> "Gravitino"}}
        };    
        
        
        
 WeylFermionAndIndermediate = {
       {FHd0, { Description -> "Neutral Down-Higgsino"}},      
       {FHu0, { Description -> "Neutral Up-Higgsino" }}, 
       {FHdm, { Description -> "Charged Down-Higgsino"}},    
       {FHup, { Description -> "Charged Up-Higgsino"}},
       {L0,   { Description -> "Neutralino Weyl-Spinor"}},
       {Lm,   { Description -> "Negative Chargino Weyl-Spinor"}},
       {Lp,   { Description -> "Positive Chargino Weyl-Spinor"}}, 
       {fG,   { Description ->"Gluino Weyl-Spinor"}},
       {fWB,  { Description ->"Wino Weyl-Spinor"}},
       {fW0,  { Description ->"Neutral Wino" }},
       {fWm,  { Description ->"Negative Wino"}},                 
       {fWp,  { Description ->"Positive Wino"}},                 
       {fB,   { Description ->"Bino Weyl-Spinor"}},    
       {phid, { Description -> "Scalar Down"}},                                                                       
       {phiu, { Description -> "Scalar Up"}}, 
       {sigmad,   { Description -> "Pseudo Scalar Down"}},                                                                                        
       {sigmau,   { Description -> "Pseudo Scalar Up" }},
       {SHd,  { Description -> "Down-Higgs"}},
       {SHu,  { Description -> "Up-Higgs"}},
       {Sl,   { Description -> "Left Slepton" }},
       {Sq,   { Description -> "Left Squark" }},
       {FeL,  { Description -> "Left Electron" }},
       {FeR,  { Description -> "Right Electron" }} ,
       {FdL,  { Description -> "Left Down-Quark" }},
       {FdR,  { Description -> "Right Down-Quark" }},              
       {FuL,  { Description -> "Left Up-Quark" }},
       {FuR,  { Description -> "Right Up-Quark" }},
       {FEL,  { Description -> "Rotated Left Electron" }},
       {FER,  { Description -> "Rotated Right Electron" }} ,
       {FDL,  { Description -> "Rotated Left Up-Quark" }},
       {FDR,  { Description -> "Rotated Right Up-Quark" }},              
       {FUL,  { Description -> "Rotated Left Down-Quark"}},
       {FUR,  { Description -> "Rotated Right Down-Quark" }},                
       {FHd,  { Description -> "Down-Higgsino" }},
       {FHu,  { Description -> "Up-Higgsino" }},
       {Fl,   { Description -> "Left Leptons"}},
       {Fq,   { Description -> "Left Quarks"}},  
       {FvL,  { Description -> "Left Neutrino"}},                  

       {e,    { Description -> "Right Electron Superfield" }},
       {d,    { Description -> "Right Down-Quark Superfield" }},                 
       {q,    { Description -> "Left Quark Superfield" }},                 
       {u,    { Description -> "Right Up-Quark Superfield" }},                 
       {l,    { Description -> "left Lepton Superfield" }},  
       {Hd,   { Description -> "Down-Higgs Superfield"}},                                         
       {Hu,   { Description -> "Up-Higgs Superfield" }},                 
       {G,    { Description -> "Gluon Superfield" }},                 
       {B,    { Description -> "B Superfield" }},                 
       {WB,   { Description -> "W Superfield" }},
     
       {Gol,  { Description -> "Weyl Goldstino"}},
       {GMu,  { Description -> "Weyl Gravitino"}},
      {Ft1,  {LaTeX -> "{t'}"}},
      {Ft2,  {LaTeX -> "{\\bar{t}}'"}}

    };                 
